<template>
  <FloatingCreateButton
    :shown="isShown"
    @click="isShown = true"
  />

  <v-dialog
    v-model="isShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-plus"
        headline="Создание тарифа"
        subtitle="Заполните данные"
      />

      <section class="pt-4">
        <FormRow label="Название тарифа">
          <v-text-field
            v-model="newRate.name"
            :rules="[validateName]"
            :maxlength="MAX_RATE_NAME_LENGTH"
            placeholder="Название"
          />
        </FormRow>

        <FormRow label="Стоимость тарифа">
          <NumberInput
            v-model="newRate.profit"
            mode="price"
            :hint="profitHint"
            :min="MIN_RATE_PROFIT"
            :max="INT_SIZE"
            :step="50"
          />
        </FormRow>

        <Feedback
          :message="feedback"
          type="error"
          classes="mt-4"
        />

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            :class="{ 'opacity-50': !isDataFilled }"
            :readonly="!isDataFilled"
            :loading="isLoading"
            @click="onCreateClick"
          >
            Создать
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="isShown = false"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { computed, reactive, ref, watch } from 'vue';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';
import FloatingCreateButton from '@/components/layout/FloatingCreateButton.vue';

import NumberInput from '@/components/content/NumberInput.vue';
import Feedback from '@/components/content/Feedback.vue';

import { createStringValidator } from '@/validators';
import { useRatesStore } from '@/stores';

import {
  MIN_RATE_NAME_LENGTH,
  MAX_RATE_NAME_LENGTH,
  MIN_RATE_PROFIT,
  DEFAULT_RATE_PROFIT,
  INT_SIZE,
} from '@/declarations';

const ratesStore = useRatesStore();
const validateName = createStringValidator({
  required: true,
  length: { min: MIN_RATE_NAME_LENGTH, max: MAX_RATE_NAME_LENGTH },
});

const isLoading = ref(false);
const isShown = ref(false);
const feedback = ref('');

const newRate = reactive({
  name: '',
  profit: DEFAULT_RATE_PROFIT,
});

const profitHint = computed(() => {
  return !newRate.profit ? 'Этот тариф будет бесплатным' : '';
});

const isDataFilled = computed(() => {
  const isNameEntered = validateName(newRate.name) === true;
  const isProfitEntered = newRate.profit >= MIN_RATE_PROFIT;

  return isNameEntered && isProfitEntered;
});

const onCreateClick = async () => {
  isLoading.value = true;

  const { data: { error } } = await ratesStore.createRate({
    name: newRate.name.trim(),
    profit: newRate.profit,
  });

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  isShown.value = false;
};

watch(isShown, () => {
  newRate.name = '';
  newRate.profit = DEFAULT_RATE_PROFIT;

  feedback.value = '';
});
</script>